unit Pw_ppreg;

interface


uses  dsgnintf, classes, sysutils, PW_PrPro, PW_CpPro;

type
   tdateproperty = class (tfloatproperty)
   public
       function getvalue:string; override;
       procedure setvalue (const v : string); override;
   end;

   tcodeproperty = class (tintegerproperty)
   public
       procedure setvalue (const v : string); override;
   end;

   tprotectoreditor = class (tcomponenteditor)
   public
      procedure edit; override;
   end;

procedure register;

implementation

uses pw_ppcrg, forms;

procedure register;
begin
   registercomponents ('PWR', [TProgramProtector]);
   registercomponents ('PWR', [TShareWareNotice, TCopyProtectNotice]);
   registercomponents ('PWR', [TExpiredProductNotice, TIllegalModifyNotice]);
   registercomponents ('PWR', [TRegistrationForm, TGoodRegistration]);
   registercomponents ('PWR', [TBadRegistration, TBadDate]);
   registerpropertyeditor (typeinfo(tdatetime), nil, '', tdateproperty);
   registerpropertyeditor (typeinfo(longint), tProgramProtector, 'MaxRetry', tcodeproperty);
   registerpropertyeditor (typeinfo(TProtectorInterface), tProgramProtector, 'InterfacerData', tclassproperty);
   registercomponenteditor (TProgramProtector, TProtectorEditor);
end;

function tdateproperty.getvalue:string;
begin
    result := datetostr(getfloatvalue);
end;
procedure tdateproperty.setvalue (const v : string);
begin
   setfloatvalue (strtodate (v));
end;
procedure tcodeproperty.setvalue (const v : string);
var
   val : longint;
begin
   val := strtoint (v);
   if val <= 2 then
      raise EPropertyError.create ('Value must be greater then 1');
   setordvalue (val);
end;

procedure tprotectoreditor.edit;
var
   f : TProgramProtectorRegistration;
begin
   try
      f := TProgramProtectorRegistration.create (application);
      f.showmodal;
   finally
      f.free;
   end;
end;
end.
